using System;
using System.Collections.Generic;
using GPUTools.Physics.Scripts.Kernels;
using MacGruber;
using UnityEngine;

namespace CheesyFX
{
    public static class NippleManager
    {
	    
		
		public static JSONStorableBool enabledJ = new JSONStorableBool("Nipple Errection Enabled", true);
		public static JSONStorableFloat stimulationRegression = new JSONStorableFloat("Stimulation Regression", .1f, 0f, 1f);
		public static JSONStorableFloat stimulationGain = new JSONStorableFloat("Stimulation Gain", .2f, 0f, 1f);
		public static JSONStorableFloat erectionGain = new JSONStorableFloat("Erection Gain", .2f, 0f, .3f);
		public static JSONStorableFloat erectionRegression = new JSONStorableFloat("Erection Regression", .05f, 0f, 1f);
		public static JSONStorableFloat bleed = new JSONStorableFloat("Other Side Bleed", .1f, 0f, 1f);
		
		public static NippleDriver[] nippleDrivers;
		
		// public static JSONStorableFloat test1 = new JSONStorableFloat("test1", 0f, 0f, 1f);
		// public static JSONStorableFloat test2 = new JSONStorableFloat("test2", 1f, 1f, 10f);
		// public static JSONStorableFloat test3 = new JSONStorableFloat("test3", 0f, .5f, 10f);

		public static void Init()
		{
			nippleDrivers = new[]
			{
				TouchMe.singleton.gameObject.AddComponent<NippleDriver>(),
				TouchMe.singleton.gameObject.AddComponent<NippleDriver>()
			};
			nippleDrivers[0].Init(0);
			nippleDrivers[1].Init(1);

			enabledJ.setCallbackFunction += val =>
			{
				foreach (var nipple in nippleDrivers)
				{
					if(!val) nipple.Reset();
					nipple.enabled = val;
				}
			};
			
			TouchMe.singleton.RegisterFloat(stimulationGain);
			TouchMe.singleton.RegisterFloat(stimulationRegression);
			TouchMe.singleton.RegisterFloat(erectionGain);
			TouchMe.singleton.RegisterFloat(erectionRegression);
			TouchMe.singleton.RegisterFloat(bleed);
			TouchMe.singleton.RegisterBool(enabledJ);
			
			// test1.setCallbackFunction += val =>
			// {
			// 	nippleDrivers[0].nippleMorph.morphValue = val;
			// };
			// test2.setCallbackFunction += val =>
			// {
			// 	nippleDrivers[0].nippleSprings[3].val = val;
			// };
			// test3.setCallbackFunction += val =>
			// {
			// 	nippleDrivers[0].nippleDampers[3].val = val;
			// };
		}

		public static void Stimulate(float stimulus, int side){
			// nippleDrivers[side].Stimulate(stimulus);
			ReadMyLips.Stimulate(10f*stimulus, doStim:true);
		}

		public static List<object> CreateUI(){

			List<object> UIElements = new List<object>();
			enabledJ.CreateUI(UIElements:UIElements);
			var button = TouchMe.singleton.CreateButton("Reset", true);
			button.button.onClick.AddListener(() => nippleDrivers.ToList().ForEach(x => x.Reset()));
			UIElements.Add(button);
			for (var i = 0; i < nippleDrivers.Length; i++)
			{
				var nipple = nippleDrivers[i];
				nipple.stimulation.CreateUI(UIElements: UIElements, rightSide:i==1);
				nipple.erection.CreateUI(UIElements: UIElements, rightSide:i==1);
			}

			// stimulationBuildUpOnStay.CreateUI(UIElements);
			// stimulationBuildUpOnEnter.CreateUI(UIElements, true);
			stimulationGain.CreateUI(UIElements:UIElements);
			stimulationRegression.CreateUI(UIElements:UIElements);
			erectionGain.CreateUI(UIElements:UIElements, rightSide:true);
			erectionRegression.CreateUI(UIElements:UIElements, rightSide:true);
			bleed.CreateUI(UIElements:UIElements);
			
			// test1.CreateUI(UIElements:UIElements);
			// test2.CreateUI(UIElements:UIElements);
			// test3.CreateUI(UIElements:UIElements);
			// UIManager.SetTabElements(UIElements);
			return UIElements;

			// button = Utils.SetupButton(script, "Reset stimulation", () => stimulation.val = 0f, true);
			// UIElements.Add(button);

			// button = Utils.SetupButton(script, "Reset erection", () => erection.val = 0f, true);
			// UIElements.Add(button);

			// popup = script.CreateFilterablePopup(addRegionChoice);
			// UIElements.Add(popup);
		}
    }
}